/*
 * Created on 2003. 4. 2.
 *
 */
package kr.jikiry.keymgmt;

import java.io.File;
import java.io.FileInputStream;
import java.security.Key;
import java.security.KeyStore;
import java.security.cert.Certificate;
import java.util.Enumeration;

import kr.jikiry.util.logging.Logger;
import kr.jikiry.util.logging.LoggerFactory;
import kr.jikiry.*;

/**
 * @author ȣ
 *
 * ڹٿ ⺻ ϴ keystore   ִ Ŭ.
 *  Ŭ ϱ   keystore ÿ ϴ ȮѴ.
 *  ýȯ溯 javax.net.ssl.keyStore  javax.net.ssl.keyStorePassword
 *  Ͽ Ȯ KeyStore   ִ.
 *  Ŭ   Ű ų Ű   
 *  KeyStore ϵ Ű  Ȯ  ִ.
 * 
 */
public class KeyStoreHandler {
	
	KeyStore keyStore = null;
	String keyStorePath = null;
	String keyStorePwd = null;
	Logger logger = null;
	
	public KeyStoreHandler() throws KeyStoreException{
		logger = LoggerFactory.getLogger();
		logger.info("KeyStoreHandler  ");
		keyStorePath = getKeyStorePath();
		keyStorePwd = getKeyStorePwd();
		keyStore = getKeyStoreInstance();
		keyStore = loadKeyStore(keyStore, keyStorePath, keyStorePwd);
	}

	public KeyStoreHandler(String keyStorePath, String keyStorePwd)
		throws KeyStoreException{
		
		logger = LoggerFactory.getLogger();
		logger.info("KeyStoreHandler  ");
		this.keyStorePath = keyStorePath;
		this.keyStorePwd = keyStorePwd;
		keyStore = getKeyStoreInstance();
		keyStore = loadKeyStore(keyStore,keyStorePath,keyStorePwd);
	}
	
	/**
	 * ⺻ Ű ü ̿Ͽ  Ű ġ йȣ 
	 *  ü ޸𸮿 εϴ ޼ҵ
	 * @param store
	 * @return Object
	 */
	public KeyStore loadKeyStore(KeyStore store, String keyStorePath, String keyStorePwd) 
	throws KeyStoreException{
		
		logger.info("KeyStore ε:"+keyStorePath);
		try {
			store.load(new FileInputStream(keyStorePath),keyStorePwd.toCharArray());
		} catch (Exception e) {
			e.printStackTrace();
			throw new KeyStoreException();
	
		}
		return store;
	}
	
	
	
	private KeyStore getKeyStoreInstance() throws KeyStoreException{
		KeyStore keyStore = null;
		
		
		try {
			keyStore = KeyStore.getInstance("JKS");
		} catch (java.security.KeyStoreException e) {
			
			e.printStackTrace();
			throw new KeyStoreException();
		}
		
		if (keyStore ==null)throw new KeyStoreException();
		return keyStore;
	}
	
	
	
	/**
	 * ý ȯ溯 ̿Ͽ Ű йȣ о´.
	 * @return String
	 */
	private String getKeyStorePwd() {
		String keyStorePwd = null;
		keyStorePwd = System.getProperty("javax.net.ssl.keyStorePassword");
		if (keyStorePwd == null || keyStorePwd.length()==0){
			keyStorePwd = "bbmspwd";
			System.setProperty("javax.net.ssl.keyStorePassword",keyStorePwd);
		}
		return keyStorePwd;
		
	}
	/**
	 * ý ȯ溯 ̿Ͽ Ű ġ о´.
	 * 
	 * @author ȣ
	 * @return String
	 */
	private String getKeyStorePath() {
		String keyStorePath = null;
		keyStorePath = System.getProperty("javax.net.ssl.keyStore");
		if (keyStorePath==null || keyStorePath.length()==0){
			//  keystore ġ   ٸ Ȩ丮 
			// .keystore ̸ Ѵ.
			keyStorePath = System.getProperty("user.home") + File.separator + ".keystore"; 
			System.setProperty("javax.net.ssl.keyStore",keyStorePath);
		}
		return keyStorePath;
		
	}

	/**
	 *  keyStore ϵ Ű Alias Ʈ ȯѴ.
	 */
	public Enumeration getAliases() throws java.security.KeyStoreException{
		return keyStore.aliases();
		
	}

	/**
	 * alias йȣ ̿Ͽ Ű
	 * Ű(Private key) ´.
	 * 
	 * @author ȣ
	 * @param alias
	 * @param pwd
	 */
	public Key getKey(String alias, String pwd) 
		throws KeyStoreException{
		Key key = null;
		try {
			key=keyStore.getKey(alias,pwd.toCharArray());
		} catch (Exception e) {
			
			e.printStackTrace();
			throw new KeyStoreException(e);
		}
		if (key==null) throw new KeyStoreException();
		return key;
		
	}

	/**
	 *  ȯѴ.
	 * 
	 * @author ȣ
	 * @param alias
	 * @return Certificate
	 */
	public Certificate getCert(String alias) throws KeyStoreException{
		Certificate cert = null;
		try {
			cert = keyStore.getCertificate(alias);
		} catch (java.security.KeyStoreException e) {
			
			e.printStackTrace();
			throw new KeyStoreException(e);
		}
		
		if (cert == null) throw new KeyStoreException();
		return cert;
	}

}
