/*
 * Created on 2003. 4. 13.
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package kr.jikiry.xmlSig;

import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.security.PrivateKey;
import java.security.SignatureException;
import java.security.cert.CertificateException;
import java.security.cert.X509Certificate;

import kr.jikiry.keymgmt.KeyStoreException;
import kr.jikiry.keymgmt.KeyStoreHandler;
import kr.jikiry.util.logging.LoggerFactory;

import org.w3c.dom.Document;

import com.verisign.xmlsig.Signer;
import com.verisign.xpath.XPathException;

/**
 * @author calmglow
 *
 * λ TSIK ⿡ Signer Ŭ  
 * κ  Wrapper Ŭ.
 */
public class VerisignSignature implements XMLSignature {

	Signer signer = null;
	Document doc = null;
	String alias = null;
	String keyPassword = null;
	
	public VerisignSignature(){
		// System  alias key password   ִ.
		super();
	}
	public VerisignSignature(Document doc, String alias, String keyPw) 
	throws KeyStoreException, XMLSignatureException{
		this.doc =doc;
		this.alias = alias;
		this.keyPassword = keyPw;
//		try {
//			signer = new Signer(doc, (PrivateKey)keystoreHandler.getKey(alias,keyPw),(X509Certificate)keystoreHandler.getCert(alias));
//		} catch (InvalidKeyException e) {
//			LoggerFactory.getLogger().error(e);
//			throw new KeyStoreException(e);
//		} catch (NoSuchAlgorithmException e) {
//			LoggerFactory.getLogger().error(e);
//			throw new XMLSignatureException(e);
//		} catch (CertificateException e) {
//			LoggerFactory.getLogger().error(e);
//			throw new XMLSignatureException(e);
//		} 
	}
	/* (non-Javadoc)
	 * @see kr.jikiry.xmlSig.XMLSignature#sign(org.w3c.dom.Document, java.lang.String)
	 */
	public Document sign() throws XMLSignatureException, KeyStoreException {
		Document envelopeDoc = null;
		//   signer ʱȭŰ.
		if (signer == null)
			initSigner();
		try {
			envelopeDoc = signer.sign();
		} catch (InvalidKeyException e) {
			LoggerFactory.getLogger().error(e);
			throw new KeyStoreException(e);
		} catch (SignatureException e) {
			LoggerFactory.getLogger().error(e);
			throw new XMLSignatureException(e);
		} catch (NoSuchAlgorithmException e) {
			LoggerFactory.getLogger().error(e);
			throw new XMLSignatureException(e);
		} catch (XPathException e) {
			LoggerFactory.getLogger().error(e);
			throw new XMLSignatureException(e);
		}
		return envelopeDoc;
	}




	/**
	 * 
	 */
	private void initSigner() throws XMLSignatureException, KeyStoreException{
		if(alias==null || doc==null || keyPassword==null)throw new XMLSignatureException();
		KeyStoreHandler keystoreHandler = new KeyStoreHandler();
		try {
			signer = new Signer(doc, (PrivateKey)keystoreHandler.getKey(alias,keyPassword),(X509Certificate)keystoreHandler.getCert(alias));
		} catch (InvalidKeyException e) {
			LoggerFactory.getLogger().error(e);
			throw new KeyStoreException(e);
		} catch (NoSuchAlgorithmException e) {
			LoggerFactory.getLogger().error(e);
			throw new XMLSignatureException(e);
		} catch (CertificateException e) {
			LoggerFactory.getLogger().error(e);
			throw new XMLSignatureException(e);
		} 
	}
	
	
	
	/**
	 * @return
	 */
	public String getAlias() {
		return alias;
	}

	/**
	 * @return
	 */
	public Document getDoc() {
		return doc;
	}

	/**
	 * @return
	 */
	public String getKeyPassword() {
		return keyPassword;
	}

	/**
	 * @param string
	 */
	public void setAlias(String string) {
		alias = string;
	}

	/**
	 * @param document
	 */
	public void setDoc(Document document) {
		doc = document;
	}

	/**
	 * @param string
	 */
	public void setKeyPassword(String string) {
		keyPassword = string;
	}

}
