/*
 * Created on 2003. 4. 13.
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package test.xmlsig;

import java.io.File;
import java.io.IOException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

import junit.framework.TestCase;
import kr.jikiry.keymgmt.KeyStoreException;
import kr.jikiry.xmlSig.*;

/**
 * @author calmglow
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class XMLSignatureTest extends TestCase {
	
	kr.jikiry.xmlSig.XMLSignature xmlSig = null;
	Document doc  = null;
	static String SAMPLE_PATH = "C:/java/eclipse/workspace/testJikiry/misc/sample/xmlsigsample1.xml";
	/**
	 * Constructor for XMLSignatureTest.
	 * @param arg0
	 */
	public XMLSignatureTest(String arg0) {
		super(arg0);
	}
	
	/* (non-Javadoc)
	 * @see junit.framework.TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
		xmlSig = XMLSignatureFactory.newInstance();
		doc = parse(SAMPLE_PATH);
		xmlSig.setDoc(doc);
		xmlSig.setAlias("jikiry");
		xmlSig.setKeyPassword("jikirypwd");
	}

	public void testSign() throws XMLSignatureException, KeyStoreException{
		Document doc = xmlSig.sign();
		assertNotNull(doc);
		
	}
	public static Document parse(String fileName) { 
		Document document = null; 
		// Initiate DocumentBuilderFactory 
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance(); 
 
		// To get a validating parser 
		factory.setValidating(false); 
		// To get one that understands namespaces 
		factory.setNamespaceAware(true); 
 
		try { 
		  // Get DocumentBuilder 
		  DocumentBuilder builder = factory.newDocumentBuilder(); 
		  // Parse and load into memory the Document 
		  document = builder.parse( new File(fileName)); 
		  return document; 
 
		} catch (SAXParseException spe) { 
		  // Error generated by the parser 
		  System.out.println("\n** Parsing error , line " + spe.getLineNumber() 
							 + ", uri " + spe.getSystemId()); 
		  System.out.println(" " + spe.getMessage() ); 
		  // Use the contained exception, if any 
		  Exception x = spe; 
		  if (spe.getException() != null) 
			x = spe.getException(); 
		  x.printStackTrace(); 
		} catch (SAXException sxe) { 
		  // Error generated during parsing 
		  Exception x = sxe; 
		  if (sxe.getException() != null) 
			x = sxe.getException(); 
		  x.printStackTrace(); 
		} catch (ParserConfigurationException pce) { 
		  // Parser with specified options can't be built 
		  pce.printStackTrace(); 
		} catch (IOException ioe) { 
		  // I/O error 
		  ioe.printStackTrace(); 
		} 
 
		return null; 
	  }
}
